# -*- coding: utf-8 -*-

from grille_de_l_amour.appli.models import Pixel, NombreImages
from django.conf import settings

import Image
import sqlite3
import os

chemin_media = settings.MEDIA_ROOT

# Respecte l'orde des couleurs telles qu'affichées à l'écran dans la palette
TAB_COULEUR = ['000000', 'ffffff', 'ff0000', '0000ff', '00ff00', 'ffff00', 'ff00ff', '00ffff' ]

# Bien garder à l'esprit que le nommage des images respecte une nomemclature DÉCRÉMENTALE
# La première image étant nommée 'grille-8999999999.png' 
# la suivante 'grille-8999999998.png' et ainsi de suite

def ajout():
    
    # Cette partie construit une image png de 13*10 avec 
    # les informations de la base de données de la grille
    # et la sauvegrade dans le dossier static/images
    
    obj_temp = NombreImages.objects.get(nom='total')
    nb_images = int(obj_temp.valeur)

    export = Image.new('RGB', (13, 10))

    for i in range(130):

            for pixel in Pixel.objects.filter(nb = i):

                couleur_pixel_hex = TAB_COULEUR[int(pixel.couleur)]
                couleur_pixel_dec = int(couleur_pixel_hex, 16)

                rouge = (couleur_pixel_dec/256)/256
                vert = (couleur_pixel_dec/256)%256
                bleu = couleur_pixel_dec%256
                ligne = i/13
                colonne = i%13
                export.putpixel((colonne, ligne), (rouge, vert, bleu))
   
    numero_pix = 9000000000-nb_images-1   
    export.save(settings.MEDIA_ROOT + 'images/grille-{0}.png'.format(numero_pix))
    
    nb_images += 1

    obj_temp.valeur = nb_images
    obj_temp.save()


    # Cette partie ajoute une ligne à matrice.png
    # quand il y a 30 nouvelles images
    
    nb_lignes = nb_images/30 
    nb_images_rest = nb_images%30

    if (nb_images_rest == 0):


        # Récupère la matrice en cours ainsi que ses hauteur et largeur.
        matrice = Image.open(chemin_media + 'matrice.png')
        width = matrice.size[0]
        height = matrice.size[1]

        # Crée une image vide plus grande d'une ligne (10px) que la matrice précédente
        # et copie la matrice dedans.
        temp = Image.new('RGB', (width, height+10))
        temp.paste(matrice, (0, 0, width, height))

        # L'ordonnée des images de la nouvelle ligne correspond 
        # à la hauteur de la matrice précedente puisqu'elles se
        # place juste en dessous.
        y = height
        x = 0

        for i in range(29, -1, -1):

            # Compte, à rebourd, en partant de 29 jusqu'à 0
            # et ajoute cette valeur à numero_pix qui est
            # la dernière image enregistrée 
            # (s'explique par le choix de la nomenclature)             

            vignette = Image.open(chemin_media + 'images/grille-{0}.png'.format(numero_pix + i))

            # Ajoute l'image 
            temp.paste(vignette, (x, y, x+13, y+10))
            
            x += 13 # décale de la largeur d'une vignette pour la suivante

        temp.save(chemin_media + 'matrice.png')


